{
 	File:		AppleShareFileServerRegistry.p
 
 	Contains:	Registry records for file server.
 
 	Version:	Technology:	AppleShare IP 6.0
 				Release:	ASIP 6.2 SDK - Wednesday, August 25, 1999 09:29:55
 
 	Copyright:	 1995-1999 by Apple Computer, Inc., all rights reserved.
 
 	Bugs?:		For bug reports, consult the following page on
 				the World Wide Web:
 
 					http://developer.apple.com/bugreporter/
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT AppleShareFileServerRegistry;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __APPLESHAREFILESERVERREGISTRY__}
{$SETC __APPLESHAREFILESERVERREGISTRY__ := 1}

{$I+}
{$SETC AppleShareFileServerRegistryIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __FILES__}
{$I Files.p}
{$ENDC}


{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}


TYPE
	Str42								= STRING[42];
	Str199								= STRING[199];

CONST
	kFSCreatorSig				= 'ipwf';						{  Attribute Signature for FileServer Service object attributes }

																{  Attribute Types for FileServer Service object each attribute  }
	kFSServerInfoType			= 'srvr';						{  ServerInfo }
	kFSServerGreetingType		= 'gret';
	kFSCacheInfoType			= 'cach';
	kFSIdleUserInfoType			= 'idle';
	kFSAdminInfoType			= 'admm';
	kFSHTTPInfoType				= 'http';
	kFSHTTPFolderType			= 'hfol';
	kFSHTTPFileType				= 'hfil';
	kFSHTTPPluginType			= 'hplg';
	kFSMultiWebDirSig			= 'webd';						{  Multi Domain signature  }
	kFSHTTPWebDirCountType		= 'domC';
	kFSHTTPWebDirType			= '0000';
	kFSFTPInfoType				= 'ftp ';
	kFSAFPInfoType				= 'afp ';
	kFSSMBInfoType				= 'smb ';
	kFSMimeType					= 'mime';
	kFSIPFilterType				= 'filt';
	kFSMaxConnection			= 'maxc';						{  max concurrent connection  }
																{  additions for ASIP 6.2 }
	kFSRestrictToSingleLogin	= 'r2sL';						{  Boolean; default false  }
	kFSNewFolderOwner			= 'newF';						{  Boolean; default false  }
	kFSRegisterFTPwithNSL		= 'Nftp';						{  Boolean; default true  }
	kFSRegisterAFPwithNSL		= 'Nafp';						{  Boolean; default true  }
	kFSRegisterHTTPwithNSL		= 'Nweb';						{  Boolean; default true  }
	kFSAppleTalkAllowed			= 'atlk';						{  Boolean; default depends on Easy Setup  }
	kFSSendGreetingOnce			= '1grt';						{  Boolean; default true  }
	kFSSleepTime				= 'inso';						{  UInt32 in seconds; default 86400 (24 hours)  }

{ Service specific advanced options }
	kFSAFPTCPSig				= 'afpt';						{  AFP over TCP port signature  }
	kFSSMBInfoSig				= 'smb ';						{  SMB over TCP port signature  }
	kFSHTTPInfoSig				= 'http';						{  HTTP port signature  }
	kFSFTPInfoSig				= 'ftp ';						{  FTP port signature  }

	kFSPortType					= 'port';						{  port number (UInt16) for all services  }
	kFSSessionTimeout			= 'ssto';						{  session timeouts for all services (SInt32)  }

	kFSTransferTimeout			= 'trto';						{  transfer timeout for kFSFTPInfoSig (SInt32)  }
	kFSKeepAliveTimeout			= 'kato';						{  keep alive timeout for kFSHTTPInfoSig (SInt32)  }
	kFSCGITimeout				= 'cgto';						{  CGI timeout for kFSHTTPInfoSig (SInt32)  }
	kFSLogSize					= 'logs';						{  Log Size - for kFSHTTPInfoSig (UInt32)  }

{ UAM information... }
	kFSUAMInfoSig				= 'uam ';						{  Signature  }


	kFSNumUAMS					= 'uamc';						{  Number of UAMs (UInt32)  }
	kFSUAMNames					= 'uams';						{  UAM names (buffer of packed pascal strings)  }

{----------------------------------------------------------}
{		Server Preference - General Information				}
{----------------------------------------------------------}
	kFSServerInfoVersion		= 1;



TYPE
	ServerInfoPtr = ^ServerInfo;
	ServerInfo = RECORD
		versionNumber:			SInt16;									{  version number for this record  }
		fileServerVersion:		SInt16;									{  version# for file server  }
		userActivityLimit:		SInt16;									{  user activity limit in %  }
		maxLogin:				SInt16;									{  maximum client connections  }
		maxGuestAccess:			SInt16;									{  maximum number of guest and anonymous logins  }
		shutdownMinutes:		SInt16;									{  minutes until shutdown  }
	END;

{----------------------------------------------------------}
{		Server Preference - connect info & Login Greeting	}
{----------------------------------------------------------}

CONST
	kFSServerGreetingVersion	= 1;


TYPE
	ServerGreetingPtr = ^ServerGreeting;
	ServerGreeting = RECORD
		versionNumber:			SInt16;									{  version number for this record  }
		greetingMsg:			Str199;									{  login greeting  }
	END;

{----------------------------------------------------------}
{		Server Preference - Additional Cache Information	}
{----------------------------------------------------------}

CONST
	kFSCacheInfoVersion			= 1;


TYPE
	CacheInfoPtr = ^CacheInfo;
	CacheInfo = RECORD
		versionNumber:			SInt16;									{  version number for this record  }
		cacheForOthers:			SInt32;									{  memory to be reserved for other applications  }
	END;

{----------------------------------------------------------}
{		Server Preference - Idle User Information			}
{----------------------------------------------------------}
{ idleFlag bits. }

CONST
	kFSIdleDisconEnabledMask	= $0001;						{  allow to disconnect idle users  }
	kFSDisconExeptOpenFilesMask	= $0002;						{  if true, disconnect except open file users  }
	kFSDisconSuperUserMask		= $0004;						{  if true, isconnect idel super users  }
	kFSDisconNormalUserMask		= $0008;						{  if true, disconnect idle normal users  }
	kFSDisconGuestUserMask		= $0010;						{  if true, disconnect idle guest users  }


	kFSIdleUserInfoVersion		= 1;


TYPE
	IdleUserInfoPtr = ^IdleUserInfo;
	IdleUserInfo = RECORD
		versionNumber:			SInt16;									{  version number for this record  }
		idleFlag:				SInt16;									{  see above  }
		idleMinute:				SInt16;									{  max # of minute for idle users  }
		disconnectMsg:			Str199;									{  disconnect message  }
	END;

{----------------------------------------------------------}
{		Server Preference - Serial Miscelleneous Information}
{----------------------------------------------------------}

CONST
	kFSAdminInfoVersion			= 1;


TYPE
	AdminInfoPtr = ^AdminInfo;
	AdminInfo = RECORD
		versionNumber:			SInt16;									{  version number for this record  }
		namePhone:				Str31;									{  name & phone  }
		organization:			Str31;									{  organization  }
	END;

{----------------------------------------------------------}
{		Server Preference - HTTP Information				}
{----------------------------------------------------------}
{ Flag bits. 	}

CONST
	kFSMultiDomainEnabled		= $0001;						{  allow multi-domain support  }
	kFSDirListingEnabled		= $0002;						{  allow directory listing  }
	kFSAutoShareWebFolder		= $0004;						{  if on, web folder share point at start up; server will clear  }

	kFSHTTPServiceInfoVersion	= 2;

	kFSHTTPEnable				= 1;							{  enable HTTP }
	kFSHTTPLogEnable			= 1;							{  enable HTTP Log }
	kFSHTTPGuestEnable			= 1;							{  guest turned on for HTTP }


TYPE
	HTTPServiceInfoPtr = ^HTTPServiceInfo;
	HTTPServiceInfo = RECORD
		versionNumber:			SInt16;									{  version number for this record  }
		enabled:				SInt16;									{  Enable HTTP, 1-enable, 0-not enable  }
		status:					SInt16;
		logEnabled:				SInt16;									{  Enable HTTP Log, 1-enable, 0-not enable  }
		maxConnect:				SInt16;									{  HTTP maximum client connections  }
		guestEnabled:			SInt16;									{  Whether guest allowed for HTTP  }
		flag:					SInt32;									{  new field for ASIP6  }
	END;

	HTTPFolderRecPtr = ^HTTPFolderRec;
	HTTPFolderRec = RECORD
		vRefNum:				SInt16;									{  HTML folder path vRefNum }
		volumeName:				Str27;									{  HTML folder path volume name }
		volCreateDate:			UInt32;									{  HTML folder path volume creation date }
		dirID:					SInt32;									{  HTML folder path DirID }
		webFolderPath:			Str255;									{  HTML folder path. Does NOT include volume name  }
	END;

	HTTPFileRecPtr = ^HTTPFileRec;
	HTTPFileRec = RECORD
		partialPath:			Str255;									{  partial path to HTML file starting from the Web folder  }
	END;


CONST
	kFSPlugInEnable				= 1;							{  enable Plug-ins }
	kFSPlugInLoggingEnable		= 1;							{  enable Plug-in logging }


TYPE
	HTTPPlugInsRecPtr = ^HTTPPlugInsRec;
	HTTPPlugInsRec = RECORD
		pluginEnable:			SInt16;									{  Plug-ins,  1-enable, 0-not enable  }
		loggingEnable:			SInt16;									{  Plug-in logging, 1-enable, 0-not enable  }
		memSize:				SInt32;									{  Plug-in memory allocation  }
		preProcessorSpec:		FSSpec;									{  Preprocessor plugin spec  }
		postProcessorSpec:		FSSpec;									{  Postprocessor plugin spec  }
		errorSpec:				FSSpec;									{  Error plugin spec  }
	END;

	VolSpecPtr = ^VolSpec;
	VolSpec = RECORD
		vName:					Str32;									{  pascal string because FSSpec uses pascal string }
		filler:					SInt8;
		vRefNum:				SInt16;
		vCreateDate:			UInt32;
	END;


CONST
	kFSHTTPWebDirCountRecVersion = 1;


TYPE
	HTTPWebDirCountRecPtr = ^HTTPWebDirCountRec;
	HTTPWebDirCountRec = RECORD
		count:					UInt16;									{  How many HTTPWebDirRec there are  }
		version:				SInt16;									{  Version of the HTTPWebDirRec  }
	END;


CONST
	kFSWebFolderEnabled			= 1;

	kFSAddressTypeDNS			= 0;
	kFSAddressTypeIPAddress		= 1;


TYPE
	HTTPWebDirRecPtr = ^HTTPWebDirRec;
	HTTPWebDirRec = RECORD
		enabled:				UInt16;									{  1 == this web folder enabled, 0 == disabled  }
		addressType:			SInt16;									{  Indicates how to decode addressText: 0 == DNS name, 1 = IP Address (in ASCII)  }
		addressText:			Str63;									{  Domain name or IP address (in ASCII) of this web folder (pascal str) See addressType field  }
		portNumber:				UInt16;									{  Port number for this web folder's IP address (InetPort)  }
		volSpec:				VolSpec;								{  Volume specifier  }
		dirID:					SInt32;									{  Dir ID of this web folder  }
	END;

{----------------------------------------------------------}
{		Server Preference - FTP Information					}
{----------------------------------------------------------}

CONST
	kFSFTPServiceInfoVersion	= 1;


TYPE
	FTPServiceInfoPtr = ^FTPServiceInfo;
	FTPServiceInfo = RECORD
		versionNumber:			SInt16;									{  version number for this record  }
		ftpEnable:				SInt16;									{  Enable FTP, 1-enable, 0-not enable  }
		status:					SInt16;
		ftpAnonymousEnable:		SInt16;									{  Enable Anonymous Login, 1-enable, 0-not enable  }
	END;

{----------------------------------------------------------}
{		Server Preference - AFP Information					}
{----------------------------------------------------------}

CONST
	kFSAFPServiceInfoVersion	= 1;


TYPE
	AFPServiceInfoPtr = ^AFPServiceInfo;
	AFPServiceInfo = RECORD
		versionNumber:			SInt16;									{  version number for this record  }
		afpOverTCPIPEnable:		SInt16;									{  Enable AFP over TCPIP, 1-enable, 0-not enable  }
		afpOverTCPIPStatus:		SInt16;
		afpOverATalkEnable:		SInt16;									{  Enable AFP over AppleTalk, 1-enable, 0-not enable  }
	END;

{----------------------------------------------------------}
{		Server Preference - SMB Information					}
{----------------------------------------------------------}

CONST
	kFSSMBServiceInfoVersion	= 1;

	kFSSMBMaxNetBIOSnameLength	= 15;
	kFSSMBMaxWorkGroupLength	= 15;
	kFSSMBMaxCommentLength		= 43;
	kFSSMBWINSAddressLength		= 62;


TYPE
	SMBServiceInfoPtr = ^SMBServiceInfo;
	SMBServiceInfo = RECORD
		versionNumber:			SInt16;									{  version number for this record  }
		smbEnable:				SInt16;									{  Enable SMB, 1-enable, 0-not enable  }
		status:					SInt16;
		guestEnabled:			SInt16;									{  Whether guest allowed for SMB  }
		netBIOSname:			Str31;									{  Server name. Limited to 15 bytes  }
		workGroup:				Str31;									{  NETBIOS group name.  Limited to 15 bytes  }
		comment:				Str63;									{  ASCII comment for the server. Limited to 43 bytes  }
		winsEnabled:			SInt16;									{  Enable WINS, 1-enable, 0-not enable  }
		winsAddress:			Str63;									{  WINS IP address  }
	END;

{----------------------------------------------------------------------}
{		MIME type changes - Notify server SrvrMimeTypePrefs has changed	}
{----------------------------------------------------------------------}

CONST
	kFSMimeTypeChangedVersion	= 1;


TYPE
	MimeTypeChangedPtr = ^MimeTypeChanged;
	MimeTypeChanged = RECORD
		version:				SInt16;									{  version number for this record  }
		counter:				SInt32;									{  no meaning, just for notification  }
	END;

{----------------------------------------------------------}
{		IPFilter Options - Advanced option for filtering IP }
{----------------------------------------------------------}

CONST
	kFSIPFilterAllow			= 1;

{ Structure of individual filters }

TYPE
	IPFilterStructPtr = ^IPFilterStruct;
	IPFilterStruct = RECORD
		allow:					SInt16;									{  0 for disallow, 1 for allow  }
		highIPBytes:			UInt32;
		lowIPBytes:				UInt32;
	END;


CONST
	kFSMaxIPFilters				= 10;


TYPE
	IPFilterInfoPtr = ^IPFilterInfo;
	IPFilterInfo = RECORD
		versionNumber:			SInt16;									{  version number for this record  }
		numFilters:				SInt16;									{  numberOfIPFilters  }
		filters:				ARRAY [0..9] OF IPFilterStruct;
	END;

{----------------------------------------------------------}
{		Max connection information					    	}
{----------------------------------------------------------}
{
   tags for this record are type:kFSCreatorSig  and attribute:kFSMacConnextion
   this value will be used if the max connection number encoded in serial number is 250
}

CONST
	kFSServerMaxConnectionInfoVersion = 1;


TYPE
	ServerMaxConnectionInfoPtr = ^ServerMaxConnectionInfo;
	ServerMaxConnectionInfo = RECORD
		version:				SInt16;
		flag:					SInt32;									{  reserved for future use  }
		maxConnection:			SInt32;
	END;

{  -------------------------------------------------------------------------------------------------  }
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := AppleShareFileServerRegistryIncludes}

{$ENDC} {__APPLESHAREFILESERVERREGISTRY__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
