{
 	File:		AppleShareMailServerRegistry.p
 
 	Contains:	Attributes stored by the ASIP Mail Server in the Registry.
 
 	Version:	Technology:	AppleShare IP 6.0
 				Release:	ASIP 6.2 SDK - Saturday, September 4, 1999 15:05:49
 
 	Copyright:	 1996-1999 by Apple Computer, Inc., all rights reserved.
 
 	Bugs?:		For bug reports, consult the following page on
 				the World Wide Web:
 
 					http://developer.apple.com/bugreporter/
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT AppleShareMailServerRegistry;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __APPLESHAREMAILSERVERREGISTRY__}
{$SETC __APPLESHAREMAILSERVERREGISTRY__ := 1}

{$I+}
{$SETC AppleShareMailServerRegistryIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __APPLESHAREREGISTRY__}
{$I AppleShareRegistry.p}
{$ENDC}


{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

{
   *********
   Constants
   *********
}
{  Signature, type... }

CONST
	kMUMailServerSignature		= 'mail';
	kMU60Attributes				= 'mU60';						{  MailUser	6.0 }
	kMUHomeServer				= 'mUhs';						{  Home server record }

	kMUHomeServerTag			= 'Acct';

{  ASDSharedAttributeConstants  }
	kMUMaxSMTPForwardLength		= 255;
	kMUFingerprintLength		= 16;

{
   ***************
   User Attributes
   ***************
}

{  ASDMailUserFlags }
	KMUUserEnableMask			= $0000000F;
	kMUAPOPRequired				= $00000004;					{  User must use APOP to authenticate }
	kMUForwardingMask			= $000000F0;					{  Mask to get forwarding options }
	kMUNoForwarding				= $00000010;					{  enabled mail...this bit should be set.. }
	kMUForwardSMTP				= $00000020;					{  Forward mail to SMTP address }
	kMUForwardATalk				= $00000040;					{  Forward mail to AppleTalk SMTP server }
																{  6.0 flag additions }
	kMUIMAPPOPFlagsMask			= $00000F00;
	kMUPOPEnabled				= $00000100;					{  User can connect over POP3 or PASS }
	kMUIMAPEnabled				= $00000200;					{  User can connect over IMAP or PASS }
	kMUNotificationMask			= $0000F000;
	kMUNotificationON			= $00001000;					{  User wants mail notification }
	kMUUseLastIPAddr			= $00002000;					{  Use last IP Address for notification - notifyIPAddress is ignored.. }
	kMUUseSpecificIPAddr		= $00004000;					{  field notifyIPAddress is used...and kMUUseLastIPAddr should cleared.. }
	kMUSharedBoxFlagMask		= $000F0000;
	kMUSeparatePOPAndIMAP		= $00010000;					{  User can connect over POP3, IMAP or PASS with separate inbox }
	kMUShowPOPInIMAP			= $00020000;					{  User can connect over POP3, IMAP or PASS with separate inbox }
																{  legacy, do not use beyond 5.0.x versions.. }
	kMUMailEnabled				= $00000001;					{  Was kMEEnabled in version 1 - ignore, should be zero for 6.0.. }
	kMULoginEnabled				= $00000002;					{  User can connect over POP3 or PASS  - ignore, should be zero for 6.0.. }

{  Only generate C struct info, since the ASM and Pascal will be wrong }
{
	Note: The MU5xAttributes and MU60Attributes structs must not be altered.
	The shipping code in earlier versions of our products reads and writes 
	precisely these structures and any changes to the struct size or field offsets 
	will destroy backwards compatibility with the older products.
	In other words don't use Str32Field as the atalk field types or you'll break things!
}

TYPE
	ATalkStr33							= PACKED ARRAY [0..32] OF UInt8;
{
   A 32 character Pascal string with a length byte.
   Yes, when packed things end up on odd addresses, but that's where the old code requires it to be.
}
	MU60AttributesPtr = ^MU60Attributes;
	MU60Attributes = RECORD
		version:				UInt32;
		mailUserFlags:			UInt32;
		atalkForwardName:		ATalkStr33;
		atalkForwardServer:		ATalkStr33;
		atalkForwardZone:		ATalkStr33;
		smtpForward:			PACKED ARRAY [0..255] OF CHAR;
		fingerprint:			PACKED ARRAY [0..15] OF CHAR;			{  initialize to all zeros when creating attribute }
		notifyIPAddress:		UInt32;
	END;

	MUHomeServerPtr = ^MUHomeServer;
	MUHomeServer = RECORD
		tag:					UInt32;									{  kMUHomeServerTag }
		offset:					UInt32;									{  Unused set to 0 }
		data:					Str255;									{  home server name, as a pascal string }
		reserved:				Str255;									{  set to 0 }
	END;

{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := AppleShareMailServerRegistryIncludes}

{$ENDC} {__APPLESHAREMAILSERVERREGISTRY__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
