{
 	File:		AppleShareRegistry.p
 
 	Contains:	AppleShareRegistry data types Interfaces. Formerly known as OAM and OAMTypes...
 
 	Version:	Technology:	AppleShare IP 6.0
 				Release:	ASIP 6.2 SDK - Wednesday, August 25, 1999 09:29:55
 
 	Copyright:	 1995-1999 by Apple Computer, Inc., all rights reserved.
 
 	Bugs?:		For bug reports, consult the following page on
 				the World Wide Web:
 
 					http://developer.apple.com/bugreporter/
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT AppleShareRegistry;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __APPLESHAREREGISTRY__}
{$SETC __APPLESHAREREGISTRY__ := 1}

{$I+}
{$SETC AppleShareRegistryIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __MIXEDMODE__}
{$I MixedMode.p}
{$ENDC}
{$IFC UNDEFINED __MACTYPES__}
{$I MacTypes.p}
{$ENDC}


{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}


CONST
	kOAMMachineShortID			= 0;
	kOAMOwnerShortID			= 1;

{ Object Types & Attribute Signatures}
	kOAMAnyObjectType			= '****';
	kOAMMachine					= 'mach';
	kOAMUser					= 'user';
	kOAMGroup					= 'grop';
	kOAMService					= 'serv';

{ Attribute Signatures }
	kOAMBasic					= '----';
	kOAMGestalt					= 'gest';
	kOAMClassicFS				= 'clfs';

{ Attribute Types }
																{  All Objects  }
	kOAMShortID					= 'shid';						{  UInt32  }
	kOAMName					= 'name';						{  Str31  }
	kOAMInternetName			= 'inam';						{  Str31  }
	kOAMType					= 'type';						{  OSType  }
																{  User Object Attributes  }
	kOAMPasswordAttribute		= 'pwd ';						{  char[8] (zero padded)  }
	kOAMPasswordLen				= 'pwdL';						{  UInt8  }
	kOAMUserFlags				= 'flgs';						{  UInt16  }
	kOAMUserFailedPasswordAttempts = 'blog';					{  UInt16  }
	kOAMUserPasswordCreationTime = 'pwdD';						{  UInt32 (set by OAM agent)  }
	kOAMUserNumGroups			= 'nmem';						{  UInt16 (read only)  }
	kOAMPrimaryGroup			= 'pgrp';						{  UGRec (id and name)  }
	kOAMDisableDate				= 'disD';						{  SInt32  }
	kOAMLastLogin				= 'logD';						{  SInt32  }
	kOAMUserComment				= 'cmnt';						{  Str197  }
	kOAMUserPhoneRecord			= '976 ';						{  OAMUserPhoneRecord  }
																{  Service Object Attributes  }
	kOAMShortStatus				= 'shst';						{  UInt32  }
	kOAMServiceFlags			= 'flag';						{  OAMFlags  }
	kOAMServicePSN				= 'psn ';						{  ProcessSerialNumber  }
	kOAMServiceFSSpec			= 'fssp';						{  FSSpec  }
	kOAMServiceClass			= 'styp';						{  OSType  }
																{ 	kOAMServiceType was renamed to kOAMServiceClass. }
																{ 	6/15/1999 AKN }
																{ 	kOAMServiceType 					= 'styp',	/* OSType */	 }
	kOAMServiceFileType			= 'type';						{  OSType  }
	kOAMServiceCreator			= 'crtr';						{  OSType  }
																{  Machine Object Attributes  }
	kOAMGuestProgramLinking		= 'gstl';						{  SInt16  }
	kOAMNoGuestAccess			= 'gsta';						{  SInt16  }
	kOAMProgramLinking			= 'prgl';						{  SInt16  }
	kOAMBoot					= 'boot';						{  SInt16  }
	kOAMFileSharingEnabled		= 'fshr';						{  SInt16  }
	kOAMApple2Mode				= 'apl2';						{  SInt16  }
	kOAMNoSavePassword			= 'spwd';						{  SInt16  }
	kOAMMultihoming				= 'mlth';						{  SInt16  }
	kOAMGuestInited				= 'gsti';						{  SInt16  }
	kOAMUGInited				= 'ugin';						{  SInt16  }
	kOAMUGFileVersion			= 'vers';						{  SInt16 (read only)  }
	kOAMServerName				= 'name';						{  Str32  }
	kOAMDefaultShutdown			= 'smin';						{  SInt16  }
	kOAMMinPasswordLen			= 'plen';						{  UInt8  }
	kOAMMaxBadLogins			= 'bmax';						{  SInt16  }
	kOAMMaxPwdChgTime			= 'pwdc';						{  SInt16  }
	kOAMLoginDisabledTime		= 'disT';						{  SInt32  }
	kOAMUniqueID				= 'uniq';						{  SInt32  }
	kOAMMoreSFlags				= 'msfl';						{  OAMFlags  }
	kOAMOtherFlags				= 'oflg';						{  OAMFlags  }
	kOAMOTPort					= 'port';						{  SInt16  }
	kOAMEasySetupVersion		= 'easy';						{  NumVersionVariant  }

{ userFlag bits }
	kOAMDefaultNewUserSettings	= 0;
	kOAMIACEnabledMask			= $0001;						{  IAC is enabled for this user  }
	kOAMLoginEnabledMask		= $0100;						{  Login is enabled for this user  }
	kOAMSuperUserMask			= $0200;						{  This user is a superuser  }
	kOAMDisableChangePwdMask	= $0400;						{  User CANNOT change password  }
	kOAMGetNewPwdMask			= $1000;
	kOAMUserExpiredMask			= $2000;						{  User has been expired  }

{ kShortStatus codes for registered services }
	kOAMServiceNotRunning		= 1;
	kOAMServiceRunning			= 2;
	kOAMServiceStartingUp		= 3;
	kOAMServiceShutingDown		= 4;

	kOAMServiceAutoLaunch		= $00000001;					{  Launch on startup  }
	kOAMServiceAutoShutdown		= $00000002;					{  Shutdown on quit  }


TYPE
	OAMEventCode						= UInt32;
	OAMStatus							= OSStatus;
	OAMCallID							= UInt32;
	OAMSessionID						= UInt32;
	OAMType								= OSType;
	OAMTypePtr							= ^OAMType;
	OAMObjectType						= OSType;
	OAMFlags							= UInt32;
	OAMShortObjectSpec					= UInt32;
	OAMShortObjectSpecPtr				= ^UInt32;

CONST
	kOAMOptionFlags				= 'oflg';
	kOAMOptionThreadBlockCall	= 'tpre';
	kOAMOptionThreadYieldCall	= 'tpos';
	kOAMOptionThreadUnblockCall	= 'twak';

	kOAMOptionThreadMgr			= 1;
	kOAMOptionExternalThreadMgr	= 2;


TYPE
	OAMOptionPtr = ^OAMOption;
	OAMOption = RECORD
		option:					OSType;
		value:					UInt32;
	END;


CONST
	kOAMLocatorAppletalk		= 0;


TYPE
	OAMServerLocatorPtr = ^OAMServerLocator;
	OAMServerLocator = RECORD
		specSize:				UInt16;									{  total size of this locator spec struct  }
		protType:				UInt32;									{  kOAMLocatorAppletalk -> appletalk  }
		reserved1:				UInt32;
		reserved2:				UInt32;									{  probably script  }
		name:					Str63;
		protSpecific:			PACKED ARRAY [0..3] OF UInt8;			{  variable size protocol specific part  }
	END;


CONST
	kOAMServerAppleTalk			= 0;


TYPE
	OAMServerSpecPtr = ^OAMServerSpec;
	OAMServerSpec = RECORD
		specSize:				UInt16;									{  total size of this server spec struct  }
		protType:				UInt32;									{  kOAMServerAppleTalk -> appletalk  }
		reserved1:				UInt32;
		reserved2:				UInt32;
		name:					Str63;
		protSpecific:			PACKED ARRAY [0..3] OF UInt8;			{  variable size protocol specific part  }
	END;

{ Special User IDs }

CONST
	kOAMGuestUserID				= 0;
	kOAMMachineOwnerUserID		= 1;

{ Agent Status }
	kOAMAgentNotInstalled		= 0;
	kOAMAgentNotRunning			= 1;
	kOAMAgentStartingUp			= 2;
	kOAMAgentRunning			= 3;
	kOAMAgentShuttingDown		= 4;
	kOAMAgentNotRunningATTClose	= 5;
	kOAMAgentGenesis			= 6;

{ specType }
	kOAMObjectSpecNull			= 0;
	kOAMObjectSpecByShortID		= 1;
	kOAMObjectSpecByNameType	= 2;


TYPE
	OAMObjectSpecPtr = ^OAMObjectSpec;
	OAMObjectSpec = RECORD
		objectType:				OAMType;
		specType:				OAMType;								{  kOAMObjectSpecByShortID->short id, kOAMObjectSpecByNameType->nametype and others...  }
		CASE INTEGER OF
		0: (
			shortID:			OAMShortObjectSpec;
			);
		1: (
			name:				Str31;
			);
		2: (
			otherTypes:			PACKED ARRAY [0..3] OF UInt8;
			);
	END;

{ keyType }

CONST
	kOAMKeyClearText			= 0;


TYPE
	OAMKeyPtr = ^OAMKey;
	OAMKey = RECORD
		keyType:				OAMType;								{  kOAMKeyClearText->cleartext password  }
		keyBufferLen:			UInt32;
		keyBuffer:				PACKED ARRAY [0..7] OF UInt8;
	END;

	OAMBufferDescriptorPtr = ^OAMBufferDescriptor;
	OAMBufferDescriptor = RECORD
		buffer:					Ptr;
		bufferLen:				UInt32;
		actCount:				UInt32;
	END;

	OAMAttributeDescriptorPtr = ^OAMAttributeDescriptor;
	OAMAttributeDescriptor = RECORD
		attributeSignature:		OAMType;
		attributeType:			OAMType;
		bufferDescriptor:		OAMBufferDescriptor;
		status:					OSStatus;
		offset:					UInt32;
		actSize:				UInt32;
	END;

{ iterationType }

CONST
	kOAMIterObjects				= 1;
	kOAMIterMembers				= 2;
	kOAMIterMemberships			= 3;

{ iterationFlags }
	kOAMIterByIndex				= 1;
	kOAMIterByObject			= 2;


TYPE
	OAMSpecOrIndexPtr = ^OAMSpecOrIndex;
	OAMSpecOrIndex = RECORD
		CASE INTEGER OF
		0: (
			startingObject:		OAMObjectSpecPtr;
			);
		1: (
			startingIndex:		UInt32;
			);
	END;

	OAMIterationSpecPtr = ^OAMIterationSpec;
	OAMIterationSpec = RECORD
		iterationType:			OAMType;
		iterationFlags:			OAMFlags;
		typeList:				OAMTypePtr;
		iterArgument:			OAMObjectSpecPtr;
		maxToGet:				UInt32;
		u:						OAMSpecOrIndex;
																		{  set by call  }
		totalSize:				UInt32;
		lastPosition:			UInt32;
		more:					BOOLEAN;
	END;

	OAMParseInfoPtr = ^OAMParseInfo;
	OAMParseInfo = RECORD
		reserved:				ARRAY [0..31] OF UInt32;
	END;

{ optionType }

CONST
	kOAMNotifyStartOption		= 'nstt';
	kOAMNotifyStopOption		= 'nstp';
	kOAMNotifySelfOption		= 'nslf';

{ notify OAMOptionsFlags }
	kOAMOptionUserData			= 2;

{ notifyID }
	kOAMNotifyNewObject			= 1;
	kOAMNotifyDeleteObject		= 2;
	kOAMNotifyRenameObject		= 3;
	kOAMNotifyAttributeSet		= 4;
	kOAMNotifyMemberAdd			= 5;
	kOAMNotifyMemberRemove		= 6;
	kOAMNotifyLogin				= 7;
	kOAMNotifyAll				= 8;
	kOAMMaxNotify				= 8;


TYPE
	OAMBooleanOptionPtr = ^OAMBooleanOption;
	OAMBooleanOption = RECORD
		value:					UInt16;
	END;


CONST
	kOAMNotifyAllObjects		= -1;


TYPE
	OAMNotifyOptionPtr = ^OAMNotifyOption;
	OAMNotifyOption = RECORD
		notifyID:				UInt32;
		objectID:				UInt32;									{  kOAMNotifyAllObjects -> all objects  }
	END;

	OAMNotificationSpecPtr = ^OAMNotificationSpec;
	OAMNotificationSpec = RECORD
		oamType:				OAMType;
		bufferDescriptor:		OAMBufferDescriptor;
	END;

	OAMNotificationPtr = ^OAMNotification;
	OAMNotification = RECORD
		version:				UInt16;									{  0  }
		sess:					OAMSessionID;
		objectID:				OAMShortObjectSpec;
		notifyID:				UInt32;									{  notifyID = kOAMNotifyNewObject | kOAMNotifyAttributeSet | ....  }
		userData:				UInt32;
		CASE INTEGER OF
		0: (
			oamType:			OAMType;
			);
		1: (
			member:				OAMShortObjectSpec;
			);
	END;

{ OAM Notification Support }
{$IFC TYPED_FUNCTION_POINTERS}
	OAMNotificationProcPtr = PROCEDURE(VAR notification: OAMNotification); C;
{$ELSEC}
	OAMNotificationProcPtr = ProcPtr;
{$ENDC}

	OAMNotificationUPP = UniversalProcPtr;

CONST
	uppOAMNotificationProcInfo = $000000C1;

FUNCTION NewOAMNotificationUPP(userRoutine: OAMNotificationProcPtr): OAMNotificationUPP; { old name was NewOAMNotificationProc }
	{$IFC TARGET_OS_MAC AND TARGET_CPU_68K AND NOT TARGET_RT_MAC_CFM}
	INLINE $2E9F;
	{$ENDC}

PROCEDURE DisposeOAMNotificationUPP(userUPP: OAMNotificationUPP);
	{$IFC TARGET_OS_MAC AND TARGET_CPU_68K AND NOT TARGET_RT_MAC_CFM}
	INLINE $584F;
	{$ENDC}

PROCEDURE InvokeOAMNotificationUPP(VAR notification: OAMNotification; userRoutine: OAMNotificationUPP); { old name was CallOAMNotificationProc }
{ session option }

CONST
	kOAMOptionMemory			= ' mem';

{ authentication flags }
	kOAMAuthLogin				= 0;
	kOAMAuthLoginContinue		= 1;
	kOAMAuthChangeKey			= 2;
	kOAMAuthChangeKeyContinue	= 3;

	kOAMAuthStream				= 1;


TYPE
	OAMAuthenticateInfoPtr = ^OAMAuthenticateInfo;
	OAMAuthenticateInfo = RECORD
		objectSpec:				OAMObjectSpecPtr;
		flags:					UInt16;
		stage:					UInt16;									{  intialial set to zero  }
		objStatus:				OAMStatus;
		uam:					PACKED ARRAY [0..63] OF UInt8;
		reserved:				PACKED ARRAY [0..63] OF UInt8;
	END;

	OAMCallNumber						= PACKED ARRAY [0..127] OF UInt8;
{ bits for phoneFlags }

CONST
	kOAMLoginBit				= 0;
	kOAMCallbackBit				= 1;


TYPE
	OAMUserPhoneRecordPtr = ^OAMUserPhoneRecord;
	OAMUserPhoneRecord = RECORD
		phoneFlags:				SInt16;
		retryCount:				SInt16;
		callNum:				OAMCallNumber;							{  callback number }
	END;

{ Error Codes }

CONST
																{  General  }
	kOAMInitializationErr		= -29300;
	kOAMParameterErr			= -29301;
	kOAMGeneralErr				= -29302;						{  Objects  }
	kOAMObjectNotFoundErr		= -29310;
	kOAMContainerObjectNotFoundErr = -29311;
	kOAMMemberObjectNotFoundErr	= -29312;
	kOAMDuplicateObjectErr		= -29320;
	kOAMCreateRestrictedErr		= -29321;
	kOAMMaximumObjectsErr		= -29330;
	kOAMMaximumMemberObjectsErr	= -29331;						{  Attributes  }
	kOAMAttributeNotFoundErr	= -29340;
	kOAMAttributeReadOnlyErr	= -29341;
	kOAMAttributeReadWriteOnlyErr = -29342;
	kOAMAttributeBufferTooSmallErr = -29343;
	kOAMAttributeBufferTooLargeErr = -29344;
	kOAMMaximumAttributesErr	= -29345;						{  Buffers  }
	kOAMBufferTooSmallErr		= -29350;
	kOAMBufferTooLargeErr		= -29351;						{  Authentication  }
	kOAMAuthenticationErr		= -29360;
	kOAMAuthenticationInProgressErr = -29361;
	kOAMLoginDisabledErr		= -29362;
	kOAMAuthenticationServerErr	= -29363;
	kOAMUAMNotFoundErr			= -29364;
	kOAMAdminDisabledErr		= -29365;
	kOAMAuthenticationAdminErr	= -29366;						{  Password  }
	kOAMPasswordNeedsChangeErr	= -29370;
	kOAMPasswordExpiredErr		= -29371;
	kOAMPasswordMinimumLenErr	= -29372;
	kOAMSamePasswordErr			= -29373;
	kOAMPasswordChangeDisabledErr = -29374;						{  Session  }
	kOAMServerNotFoundErr		= -29380;
	kOAMServerNotInstalledErr	= -29381;
	kOAMServerNotReadyErr		= -29382;
	kOAMNoMachineNameErr		= -29383;
	kOAMRequestTooLargeErr		= -29384;
	kOAMNetworkErr				= -29385;
	kOAMSessionIDErr			= -29386;
	kOAMMaximumSessionsErr		= -29387;
	kOAMSecondaryBusyErr		= -29388;

	kOAMParseDone				= 99;

FUNCTION OAMInitialize(numSessions: UInt32; maxNumCalls: UInt32; VAR buffer_i: OAMBufferDescriptor; VAR flags_i: OAMOption): OAMStatus; C;

FUNCTION OAMDeInitialize: OAMStatus; C;
FUNCTION OAMFindServer(VAR locator_i: OAMServerLocator; VAR buffer_o: OAMBufferDescriptor; VAR numInBuffer_o: UInt32; VAR numFound_o: UInt32; VAR options: OAMOption): OAMStatus; C;

FUNCTION OAMFindServerExtract(VAR buffer_i: OAMBufferDescriptor; index_i: UInt32; VAR spec_o: OAMServerSpec): OAMStatus; C;

FUNCTION OAMGetSize(numSessions: UInt32; maxNumCalls: UInt32): UInt32; C;
FUNCTION OAMGetLocalServerStatus(VAR serverStatus: UInt32): OAMStatus; C;
FUNCTION OAMOpenSession(VAR server_i: OAMServerSpec; VAR sessID_o: OAMSessionID; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMCloseSession(sessID_o: OAMSessionID; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMAuthenticateSession(sessID: OAMSessionID; VAR user: OAMObjectSpec; VAR key: OAMKey; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMCreateObject(sessID: OAMSessionID; VAR object: OAMObjectSpec; VAR attr: OAMAttributeDescriptor; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMDeleteObject(sessID: OAMSessionID; VAR object: OAMObjectSpec; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMGetAttribute(sessID: OAMSessionID; VAR object: OAMObjectSpec; VAR attr: OAMAttributeDescriptor; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMSetAttribute(sessID: OAMSessionID; VAR key: OAMObjectSpec; VAR attr: OAMAttributeDescriptor; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMDeleteAttribute(sessID: OAMSessionID; VAR object: OAMObjectSpec; VAR attr: OAMAttributeDescriptor; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMIsGroupMember(sessID: OAMSessionID; VAR group: OAMObjectSpec; VAR member: OAMObjectSpec; VAR isMember: BOOLEAN; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMAddGroupMember(sessID: OAMSessionID; VAR group: OAMObjectSpec; VAR newMember: OAMObjectSpec; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMRemoveGroupMember(sessID: OAMSessionID; VAR group: OAMObjectSpec; VAR oldMember: OAMObjectSpec; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMIterate(sessID: OAMSessionID; VAR iterSpec: OAMIterationSpec; VAR desc: OAMAttributeDescriptor; VAR buffer: OAMBufferDescriptor; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMParseAttributeBuffer(VAR buffer: OAMBufferDescriptor; VAR desc: OAMAttributeDescriptor; VAR parseInfo: OAMParseInfo): OAMStatus; C;
FUNCTION OAMParseGetNextObject(VAR parseInfo: OAMParseInfo; VAR object: OAMObjectSpec): OAMStatus; C;
FUNCTION OAMParseGetNextAttribute(VAR parseInfo: OAMParseInfo; VAR attr: OAMAttributeDescriptor): OAMStatus; C;
FUNCTION OAMSetNotificationProc(sessID: OAMSessionID; procPtr: OAMNotificationUPP; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMRequestNotification(sessionID: OAMSessionID; VAR notificationSpec: OAMNotificationSpec; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMBecomeHelperThread: OAMStatus; C;
FUNCTION OAMStartService(sessID: OAMSessionID; VAR objectSpec: OAMObjectSpec; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMStopService(sessID: OAMSessionID; VAR objectSpec: OAMObjectSpec; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMAuthenticateObject(sessID: OAMSessionID; VAR authInfo: OAMAuthenticateInfo; VAR inDescriptor: OAMBufferDescriptor; VAR outDescriptor: OAMBufferDescriptor; VAR options: OAMOption): OAMStatus; C;
FUNCTION OAMChangeObjectKey(sessID: OAMSessionID; VAR authInfo: OAMAuthenticateInfo; VAR inDescriptor: OAMBufferDescriptor; VAR outDescriptor: OAMBufferDescriptor; VAR options: OAMOption): OAMStatus; C;

{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := AppleShareRegistryIncludes}

{$ENDC} {__APPLESHAREREGISTRY__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
