/*
	File:		UAM.h

	Contains:	Declarations of the Server UAM API routines

	Copyright:	 1998 by Apple Computer, Inc., all rights reserved.
*/

#pragma once

#include "OAMTypes.h"

enum { kUAMAuthLogin, kUAMAuthLoginContinue, kUAMAuthChangeKey, kUAMAuthChangeKeyContinue };
enum { kUAMAuthObject = 0, kUAMAuthStream = 1 };


#ifdef __cplusplus
extern "C" {
#endif

typedef OSStatus 	OAMStatus;
typedef OSType		OAMType;
typedef OSType		OAMObjectType;
typedef struct 		OAMObjectSpec OAMObjectSpec;
typedef UInt32		OAMShortObjectSpec, *OAMShortObjectSpecPtr;

extern OAMStatus 	UAMGetAttributeID(UInt32 id, OSType creator, OSType type, void *buffer, UInt32 *size);
extern OAMStatus 	UAMSetAttributeID(UInt32 id, OSType creator, OSType type, void *buffer, UInt32 *size);

extern OAMStatus 	UAMGetAttribute(OAMObjectSpec* obj, OSType creator, OSType type, void *buffer, UInt32 *size);
extern OAMStatus 	UAMSetAttribute(OAMObjectSpec* obj, OSType creator, OSType type, void *buffer, UInt32 *size);

extern OAMStatus 	UAMCreateObject(OAMObjectSpec* obj);
extern UInt32 		UAMGetThreadID();
extern UInt32 		UAMSleep(UInt32 msec);
extern void 		UAMWakeup(UInt32 id,UInt32 refCon);
extern OAMStatus	UAMChangeUID(UInt32 newID);

OAMStatus 			UAMAuthenticate(SInt32 operation, SInt32 id,
						void* authState, SInt32 authStateSize, void* authData, SInt32 authDataSize,
						void* authStateOut, SInt32* authStateSizeOut, void* authDataOut, SInt32* authDataSizeOut);

#ifdef __cplusplus
}
#endif

